
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Encryption de base de données - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#securite">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Encryption de base de données
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../2_CahierDesCharges/">
        Cahier des charges
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--active md-nav__item--nested">
<input checked="" class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../7_Architecture/">
        Architecture
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../9_installationEnvironnement/">
        Installation de l'environnement
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Encryption de base de données
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Encryption de base de données
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#google-authenticator">
    Google Authenticator
  </a>
<nav aria-label="Google Authenticator" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#comment-ca-fonctionne">
    Comment ça fonctionne?
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#jwt">
    JWT
  </a>
<nav aria-label="JWT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#header">
    Header
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#payload">
    Payload
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#signature">
    Signature
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#structure">
    Structure
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-portefeuille">
    Encryption portefeuille
  </a>
<nav aria-label="Encryption portefeuille" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#keystore">
    KeyStore
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#aes-encryption">
    AES Encryption
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#aes-128-ctr">
    AES-128-CTR
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-de-bases-de-donnees">
    Encryption de bases de données
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#cryptage-possible">
    Cryptage possible
  </a>
<nav aria-label="Cryptage possible" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#chiffrement-en-transit">
    Chiffrement en Transit
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#chiffrement-au-repos-at-rest">
    Chiffrement au Repos (At-Rest) :
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-realisee">
    Encryption réalisée
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../docClasse/">
        Description Classes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../conclusion/">
        Conclusion
      </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#google-authenticator">
    Google Authenticator
  </a>
<nav aria-label="Google Authenticator" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#comment-ca-fonctionne">
    Comment ça fonctionne?
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#jwt">
    JWT
  </a>
<nav aria-label="JWT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#header">
    Header
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#payload">
    Payload
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#signature">
    Signature
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#structure">
    Structure
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-portefeuille">
    Encryption portefeuille
  </a>
<nav aria-label="Encryption portefeuille" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#keystore">
    KeyStore
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#aes-encryption">
    AES Encryption
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#aes-128-ctr">
    AES-128-CTR
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-de-bases-de-donnees">
    Encryption de bases de données
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#cryptage-possible">
    Cryptage possible
  </a>
<nav aria-label="Cryptage possible" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#chiffrement-en-transit">
    Chiffrement en Transit
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#chiffrement-au-repos-at-rest">
    Chiffrement au Repos (At-Rest) :
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#encryption-realisee">
    Encryption réalisée
  </a>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="securite">Sécurité</h1>
<p>Mon projet est une application qui va demander de manipuler des données sensibles. C'est pourquoi il était indispensable de bien penser à la sécurité de celle-ci. Pour cela, j'ai dû me renseigner sur les différentes manières de sécuriser ou d'accéder. Ainsi, j'ai dû choisir le moyen qui serait le plus judicieux pour mon projet.  </p>
<p>Pour renforcer cette sécurité, j'ai mis en place une API PHP qui avait comme but de permettre uniquement d'accéder à la base de données en local. De cette manière, je faisais en sorte de faire transiter le moins de données sensibles entre le client et le serveur.</p>
<h2 id="google-authenticator">Google Authenticator</h2>
<p>Dans mon projet, l'utilisation de Google Authenticator était pour moi la manière la plus indiquée de faire fonctionner la connexion ou la confirmation.</p>
<p>Ce logiciel est utilisé pour l'authentification à deux facteurs, ce qui signifie qu'en plus de son mail et de son mot de passe d'origine, l'utilisateur est dans l'obligation d'utiliser celle-ci.</p>
<h3 id="comment-ca-fonctionne">Comment ça fonctionne?</h3>
<p>Google Authenticator est un logiciel développé par Google afin de fournir un code à 6 chiffres appelé "code éphémère". Nommé ainsi, puisque le code fourni se met à jour toutes les 30 secondes. Passé ce temps, le code est donc généré à nouveau pour en afficher un nouveau. Cela étant dit, il est important de souligner que chaque code fourni par Google Authenticator fait référence à une clé numérique propre à l'utilisateur. Dans notre cas il s'agit du QR code que l'utilisateur scanne pour lier son compte "SecuWallet" à Google Authenticator.</p>
<h2 id="jwt">JWT</h2>
<p>Les Json web token ont été créé en 2015, permettent l'échange de token sécuriser entre différentes parties. Dans mon cas j'utilise cette technologie pour ajouter une nouvelle sécurité lors de l'échange de donné entre mon client et L'API PHP.</p>
<p>Sa structure se compose en trois parties :</p>
<ul>
<li>Un header</li>
<li>un payload (data)</li>
<li>La signature numérique</li>
</ul>
<h3 id="header">Header</h3>
<p>Le header détermine quel type d'algorithme devrait être utilisée pour générer la signature. À cela vient s'ajouter l'identification du type de Token utilisé.</p>
<p>Exemple d'un header :</p>
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">  </span><span class="nt">"alg"</span><span class="p">:</span><span class="w"> </span><span class="s2">"HS256"</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="nt">"typ"</span><span class="p">:</span><span class="w"> </span><span class="s2">"JWT"</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div>
<h3 id="payload">Payload</h3>
<p>Le payload fait référence à la partie du token qui contient les informations qu'on voudrait transmettre. Ces informations sont nommées "claims", ce qui fait que nous avons la possibilité de spécifier au token les "claims" voulus.</p>
<p>Exemple d'un payload :</p>
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">  </span><span class="nt">"sub"</span><span class="p">:</span><span class="w"> </span><span class="s2">"SecuWallet"</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="nt">"name"</span><span class="p">:</span><span class="w"> </span><span class="s2">"John Doe"</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="nt">"iat"</span><span class="p">:</span><span class="w"> </span><span class="mi">1516239022</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div>
<p>Il contient ce qu'on appelle le sujet qui est régulièrement le nom de l'application (sub) pour laquelle le token est créé. Un nom unique qui permet de différencier les utilisateurs au sein de mon application (name). Pour finir un <a href="https://fr.wikipedia.org/wiki/Heure_Unix">timestamp Unix</a>(iat) qui représente la date et le temps à laquelle le token est considéré comme expiré.</p>
<h3 id="signature">Signature</h3>
<p>La signature numérique du token est un hash généré à partir de l'en-tête et des informations du jeton en utilisant l'algorithme présent dans ce dernier avec un mot de passe choisi à la génération du token. Ce hash représente toute la sécurité présente derrière cette technologie, car si une personne essaie de modifier n'importe quelle information présente dans celui-ci, le hash serait différent de celui de base. Ainsi, grâce a cette comparaison de hash on peut déterminer si le token est authentique ou non.</p>
<h3 id="structure">Structure</h3>
<p>Ces trois parties sont encodées en <a href="https://fr.wikipedia.org/wiki/Base64">bas64url</a> ainsi que concaténées avec un (".").</p>
<p>Voici un exemple de token complet qui transite entre mon client et mon API:</p>
<div class="highlight"><pre><span></span><code><span class="err">eyJhbGciOiJIUzI</span><span class="mi">1</span><span class="err">NiIsI</span><span class="kc">n</span><span class="err">R</span><span class="mi">5</span><span class="err">cCI</span><span class="mi">6</span><span class="err">IkpXVCJ</span><span class="mf">9.e</span><span class="err">yJzdWIiOiIxMjM</span><span class="mi">0</span><span class="err">NTY</span><span class="mi">3</span><span class="err">ODkwIiwibmF</span><span class="kc">t</span><span class="err">ZSI</span><span class="mi">6</span><span class="err">IkpvaG</span><span class="mi">4</span><span class="err">gRG</span><span class="mi">9</span><span class="err">lIiwiaWF</span><span class="mi">0</span><span class="err">IjoxNTE</span><span class="mi">2</span><span class="err">MjM</span><span class="mi">5</span><span class="err">MDIy</span><span class="kc">f</span><span class="err">Q.S</span><span class="kc">fl</span><span class="err">KxwRJSMeKKF</span><span class="mi">2</span><span class="err">QT</span><span class="mi">4</span><span class="kc">f</span><span class="err">wpMeJ</span><span class="kc">f</span><span class="mi">36</span><span class="err">POk</span><span class="mi">6</span><span class="err">yJV_adQssw</span><span class="mi">5</span><span class="err">c</span><span class="w"></span>
</code></pre></div>
<p>Ceci étant fait, on peut mettre les parties ensemble comme suit :</p>
<p>token = encodeBase64(header) + '.' + encodeBase64(payload) + '.' + encodeBase64(signature)</p>
<h2 id="encryption-portefeuille">Encryption portefeuille</h2>
<p>L'encryption est un pilier dans mon application puisqu'avec elle je garantis au mieux la sécurité des différents comptes et portefeuilles. Pour cela, j'utilise diverses manières afin de répondre à cette exigence.</p>
<h3 id="keystore">KeyStore</h3>
<p>La KeyStore est un fichier JSON encodé, qui contient une clé privée. De cette manière, il m'était possible de stocker les clés privées localement tout en gardant un très bon niveau de sécurité qui sera utilisé par mon projet.</p>
<h3 id="aes-encryption">AES Encryption</h3>
<p>L'utilisation de AES Encryption, me permettait de garantir la sécurité des portefeuilles stockés sur le client. Il convient de spécifier que cette encryption fait référence à une norme de sécurité cryptographique. Je tiens à souligner que celle-ci est le seul chiffrement par blocs approuvé par "NSA". C'est pourquoi il est important de spécifier que pour pouvoir cracker une clé il faudrait des milliards d'années à un supercalculateur. Ce qui démontre à quel point il serait difficile pour quelqu'un de voler des données sans avoir le mot de passe.</p>
<p>Les algorithmes AES sont donc devenus un pilier pour le monde cryptographique grâce au fait qu'elles sont impénétrables.</p>
<p>Il convient donc de dire que dans ce projet j'ai utilisé l'algorithme AES-128-CTR qui est l'exigence minimale pour utiliser le AES Encryption.</p>
<p>Sa structure est constituée comme suit:</p>
<p>{
    "crypto" : {
        "cipher" : "aes-128-ctr",
        "cipherparams" : {
            "iv" : "83dbcc02d8ccb40e466191a123791e0e"
        },
        "ciphertext" : "d172bf743a674da9cdad04534d56926ef8358534d458fffccd4e6ad2fbde479c",
        "kdf" : "scrypt",
        "kdfparams" : {
            "dklen" : 32,
            "n" : 262144,
            "p" : 8,
            "r" : 1,
            "salt" : "ab0c7876052600dd703518d6fc3fe8984592145b591fc8fb5c6d43190334ba19"
        },
        "mac" : "2103ac29920d71da29f15d75b4a16dbe95cfd7ff8faea1056c33131d846e3097"
    },
    "id" : "3198bc9c-6672-5ab3-d995-4942343ae5b6",
    "version" : 3
}</p>
<ul>
<li>cipher : algorithme de chiffrement.</li>
<li>cipherparams</li>
<li>iv: Vecteur d'initialisation 128 bits du chiffrement (vérifier qu'il soit bien aléatoire).</li>
<li>ciphertext: Texte chiffré</li>
<li>kdf : fonction de dérivation de clé</li>
<li>kdfparams</li>
<li>dklen : taille de la clé utilisée</li>
<li>n : Paramètre de coût CPU/Mémoire, doit être supérieur à 1 et puissance de 2.</li>
<li>p : paramètre de parallélisme</li>
<li>r : paramètre de taille de bloc</li>
<li>salt : valeur sécurisée de 128 bits(16 octets) ou plus et générée de manière aléatoire.</li>
<li>mac : Code utilisé pour vérifier le mot de passe (clé encodée en SHA3).</li>
<li>id : Identifiant</li>
<li>version : identifiant de la version en "dur"</li>
</ul>
<h3 id="aes-128-ctr">AES-128-CTR</h3>
<p>Il s'agit d'un chiffrement par bloc, dans notre cas le "AES-128-CTR" utilise une longueur de clé de 128 bits afin de crypter ou de décrypter un bloc de message.</p>
<h2 id="encryption-de-bases-de-donnees">Encryption de bases de données</h2>
<p>Dans le cadre de mon projet de fin d'études, j'ai trouvé pertinent de me renseigner sur différente manière d'encrypter des données et ainsi trouver celle qui me conviendrait le mieux pour ce travail. Sachant que les données ne transitent plus hors du serveur, mais directement à l'aide d'un utilisateur possédant uniquement un accès local, j'ai mis en place une API PHP que j'ai créé. L'élaboration de celle-ci a permis d'agir comme un intermédiaire entre l'application, le client c# et la base de données.</p>
<h2 id="cryptage-possible">Cryptage possible</h2>
<h3 id="chiffrement-en-transit">Chiffrement en Transit</h3>
<p>Cryptage des données entre le client et le serveur. Ce qui veut dire que ce chiffrement permet d'éviter que si les communications entre les différents intervenants sont interceptées, la personne mal veillante ne pourra rien faire de ces données collectées. J'utilise le protocole Transport Layer Security (TLS), dans l'optique de résoudre le problème des données en transit.</p>
<p>j'ai décidé de me renseigner sur des certificats autosignés et non pas des certificats qui proviennent de parties externes telles que Google, Comodo etc. Si la base de données venait à être déployée en production, il serait nécessaire d'utiliser en partie une autorité de certification externe.</p>
<p>TLS demande de manière impérative de vérifier les identités entre les différents acteurs, avant même de permettre l'échange de ces certificats et de leurs clés. </p>
<p>Il existe un outil MySQL qui se nomme mysql_ssl_rsa_setup, qui s'occupe automatiquement de la génération des clés et des certificats. Malgré cela, j'ai pris la décision d'utiliser OpenSSl pour les créer personnellement.</p>
<p>Certificats et Clés nécessaires :</p>
<ul>
<li>Clé Certificate Autority(CA) : On génère une clé privée RSA stocké dans un fichier avec l'extension Privacy Enchanced Mail (.pem)</li>
<li>Certificat CA : Il s'agit d'un certificat en format X.509, également stocké dans un fichier .pem. Il contient les métadonnées des certificats ainsi que les clés publiques.</li>
<li>Serveur CSR et Client CSR: Message adressé à une autorité de certification afin d'obtenir un certificat d'identité numérique. Il est nécessaire que les noms communs demandés soient différents.</li>
<li>Clé du serveur et Clé du client : Clé privée RSA </li>
<li>Certificat de serveur et Certificat Client : Certificat X.509 signé par la clé CA, celle-ci contient donc les métadonnées du certificat ainsi que leurs clés publiques. Il est nécessaire de spécifier que ces données sont propres à chacun.</li>
</ul>
<p>Tous ces éléments ont été stockés après leurs créations dans le répertoire suivant:
<code>/etc/mysql/transit/</code></p>
<figure id="fig2" style="width: 50%">
<img alt="Génération des certificats" src=".././img/GenerationCertificat.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 2]:</span><b>Génération des certificats</b> </figcaption>
</figure>
<p>Cette image représente les différentes entrées demandées afin de générer un certificat.</p>
<p>Il m'a été nécessaire de modifier les droits sur ce répertoire ci-dessus afin que les clés ne soient pas lisibles </p>
<figure id="fig3" style="width: 40%">
<img alt="Modification des droits sur le dossier transit" src=".././img/DroitDossierTransit.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 3]:</span><b>Modification des droits sur le dossier transit</b> </figcaption>
</figure>
<p>Afin d'activer la connexion au TLS, qui est le successeur de SSL, j'ai donc ajouté ces lignes dans le fichier de configuration de MariaDB, sous la <a href="https://stackoverflow.com/a/15453913">section</a> [mysqld].</p>
<p>Ensuite, il nous faut créer un utilisateur relié à une base, en spécifiant dans la requête le require SSL.</p>
<figure id="fig4" style="width: 40%">
<img alt="Status de la connexion en utilisant TLS" src=".././img/CipherSSL.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 4]:</span><b>Status de la connexion en utilisant TLS</b> </figcaption>
</figure>
<p>À partir d'ici nous avons la confirmation que le transit de données entre le client et le serveur est bel et bien crypté. La connexion TLS utilise l'algorithme de chiffrement dans Cipher <a href="https://ciphersuite.info/cs/TLS_DHE_RSA_WITH_AES_256_GCM_SHA384/">DHE-RSA-AES256-GCM-SHA384</a>.</p>
<h3 id="chiffrement-au-repos-at-rest">Chiffrement au Repos (At-Rest) :</h3>
<p>Il est important de noter que c'est ce cryptage que j'ai utilisé pour mon travail de diplôme.</p>
<p>Le cryptage At-Rest signifie que les fichiers de données ainsi que les logs sont encryptés dans le disque du serveur. Celle-ci rend impossible pour une personne mal intentionnée, qui arriverait à accéder aux données et a les volés, de pouvoir les lire ou d'en faire quoi que ce soit (en considérant que la clé est sécurisée et donc pas stockée localement).</p>
<p>Effectuer un cryptage At-Rest ralentit de 5 à 10% environ l'exécution des processus.</p>
<figure id="fig5" style="width: 50%">
<img alt="Performance table claire vs cryptée" src=".././img/DifferenceBaseEncrypter.com.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 5]:</span><b>Performance table claire vs cryptée</b> </figcaption>
</figure>
<p>Voici les différents éléments qui peuvent être chiffrés sur un serveur MariaDB:</p>
<ul>
<li>Fichiers de données InnoDB <a href="https://dev.mysql.com/doc/refman/8.0/en/general-tablespaces.html">(Tablespace)</a>.</li>
<li>Table Aria (uniquement supporté dans MariaDB).</li>
<li>Les différents <a href="https://dev.mysql.com/doc/refman/5.7/en/server-logs.html">log MySQL</a>.</li>
</ul>
<p>Le cryptage At-Rest de MariaDB requiert l'utilisation d'un plug-in de gestion de clé et de cryptage, dans notre cas on utilise <a href="https://mariadb.com/kb/en/file-key-management-encryption-plugin/">file_key_management</a>. Ce plug-in a malheureusement un grand défaut qui est la clé. Celle-ci peut être lue par le root donc l'utilisateur a tous les droits sur la base.</p>
<p>On génère des clés dans un répertoire <code>/etc/mysql/rest/</code>. Dans ce dossier on y trouve un fichier keyFile qui s'apparente à un tableau associatif.[id-&gt;clé]. L'id doit être un int et la clé est généré grâce OpenSSL, dans le fichier ces deux valeurs sont séparées par un ";". Comme le démontre l'image ci-dessous.</p>
<figure id="fig6" style="width: 40%">
<img alt="Contenu du fichier key" src=".././img/CatKeyfile.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 6]:</span><b>Contenu du fichier key</b> </figcaption>
</figure>
<p>Ensuite on doit créer un mot de passe qu'on stock dans un ficher keyFile.passwd qui va nous permettre d'encrypter la clé mentionnée ci-dessus, avec un algorithme symétrique qui ce nomme <a href="https://fr.wikipedia.org/wiki/Advanced_Encryption_Standard">AES</a>.</p>
<p>Voici donc les fichiers présents dans ce répertoire </p>
<figure id="fig7" style="width: 40%">
<img alt="Contenu du dossier rest" src=".././img/ContenuRest.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 7]:</span><b>Contenu du dossier rest</b> </figcaption>
</figure>
<p>Pour des raisons de sécurités, il est grandement recommandé de supprimer le keyFile (sans extension).</p>
<p>Ensuite, il est nécessaire de changer les droits dans le but de rendre la lecture des fichiers impossible.</p>
<figure id="fig8" style="width: 40%">
<img alt="Modification des droits sur le dossier rest" src=".././img/DroitRest.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 8]:</span><b>Modification des droits sur le dossier rest</b> </figcaption>
</figure>
<p>Il faut ajouter des lignes dans le fichier de configuration de MariaDB dans la section <a href="https://fr.wikipedia.org/wiki/MariaDB">MariaDB</a>.  </p>
<figure id="fig9" style="width: 50%">
<img alt="Configuration de l'encryption At-Rest" src=".././img/ConfigAtRest.PNG" width="100%"/>
<figcaption>
<span class="fig">[Fig 9]:</span><b>Configuration de l'encryption At-Rest</b> </figcaption>
</figure>
<p>Ensuite j'ai créé une table encryptée et une table classique pour comparer le contenu des fichiers comme le montre l'image ci-dessous. Ces tables ont uniquement des entées qui contiennent "Test data".</p>
<figure id="fig10" style="width: 40%">
<img alt="Table claire" src=".././img/TableClaire.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 10]:</span><b>Table claire</b> </figcaption>
</figure>
<figure id="fig11" style="width: 40%">
<img alt="Table cryptée" src=".././img/TableEnc.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 11]:</span><b>Table cryptée</b> </figcaption>
</figure>
<h2 id="encryption-realisee">Encryption réalisée</h2>
<p>Suite à mes recherches, j'ai décidé de m'orienter sur l'encryption <a href="#chiffrement-au-repos-at-rest">At-Rest</a>, puisque comme indiqué dans <a href="#encryption-de-bases-de-données">l'introduction</a> les données ne transitent plus hors du serveur.</p>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Installation de l'environnement" class="md-footer__link md-footer__link--prev" href="../9_installationEnvironnement/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Installation de l'environnement
            </div>
</div>
</a>
<a aria-label="Next: Description Classes" class="md-footer__link md-footer__link--next" href="../docClasse/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Description Classes
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>